//
//  EntryItem.m
//  TableView
//
//  Created by Andreas Bender on 15.05.10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "EntryItem.h"


@implementation EntryItem
@synthesize entryText, entryChecked;

- (id) init {
	self = [super init];
	if (self != nil) {
		self.entryText = @"";
		self.entryChecked = FALSE;
	}
	return self;
}

- (id) initWithText:(NSString *) text {
	self = [super init];
	if (self != nil) {
		self.entryText = text;
		self.entryChecked = FALSE;
	}
	return self;
}

+ (id) entryItem {
	EntryItem *item = [[[EntryItem alloc] init] autorelease];
	return item;
}

+ (id) entryItemWithText:(NSString *)text {
	EntryItem *item = [[[EntryItem alloc] initWithText:text] autorelease];
	return item;
}

#pragma mark NSCoding Protocoll

- (id) initWithCoder:(NSCoder *)aDecoder {
	if (self = [super init])
	{
		self.entryText = [aDecoder decodeObjectForKey:@"entryName"];
		self.entryChecked = [aDecoder decodeBoolForKey:@"entryChecked"];
	}
	return self;
}

- (void) encodeWithCoder:(NSCoder *)aCoder {
	[aCoder encodeObject:self.entryText forKey:@"entryName"];
	[aCoder encodeBool:self.entryChecked forKey:@"entryChecked"];
}

- (void) dealloc {
	self.entryText = NULL;
	[super dealloc];
}

@end
