#import "TableViewViewController.h"

@implementation TableViewViewController

@synthesize entries, tableView2;

/*
- (id)initWithCoder:(NSCoder *)decoder {
	self = [super init];
	if (self != nil) {
		NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
		NSData *archiv = [defaults objectForKey: @"entryItems"];
		if (archiv) {
			NSArray *array = [NSKeyedUnarchiver unarchiveObjectWithData:archiv];
			self.entries = [NSMutableArray arrayWithArray:array]; 
		} else {
			self.entries = [NSMutableArray array];
		}

	}
//	entries = [[NSMutableArray alloc]initWithObjects: nil];
	return self;
}
*/

-(IBAction)addEntry:(id)sender {
	if (!inputTextField.text)
		return;
	[inputTextField resignFirstResponder];
//	[entries addObject:inputTextField.text];
	[entries addObject:[EntryItem entryItemWithText:inputTextField.text]];
	[inputTextField setText: [NSString string]];
	addButton.enabled = NO;
	[self.tableView2 reloadData];
}



-(IBAction)nextView: (id)sender {
	
}


/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	inputTextField.delegate = self;
	
	[inputTextField setContentVerticalAlignment:UIControlContentVerticalAlignmentCenter];
	[inputTextField setClearButtonMode:UITextFieldViewModeWhileEditing];
	[inputTextField setAutocapitalizationType:UITextAutocapitalizationTypeWords];
	[inputTextField setKeyboardType:UIKeyboardTypeASCIICapable];
	[inputTextField setAutocorrectionType: UITextAutocorrectionTypeYes];
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(textFieldDidChange:) name:UITextFieldTextDidChangeNotification object:inputTextField];
	
	addButton.enabled = NO;
	
	NSUserDefaults* defaults = [NSUserDefaults standardUserDefaults];

	NSData* archive = [defaults objectForKey:@"entryItems"];
	NSArray* array = [NSKeyedUnarchiver unarchiveObjectWithData:archive];
	self.entries = [NSMutableArray arrayWithArray:array];

//	[self.tableView2 reloadData];	

}

-(BOOL)textFieldShouldReturn:(UITextField *)textField {
	if (inputTextField.text != nil && [inputTextField.text length] > 0) {
		[self addEntry: nil];
	} else 
		[inputTextField resignFirstResponder];
	
	return YES;
}

-(void)textFieldDidChange:(NSNotification *)notification {
	if (inputTextField.text != nil && [inputTextField.text length] > 0) {
		addButton.enabled = YES;
	} else {
		addButton.enabled = NO;
	}
}

-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	return 1;
}


-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return[entries count];
}


-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView2 dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
//	cell.textLabel.text = [entries objectAtIndex: indexPath.row];
	EntryItem *item = [entries objectAtIndex:indexPath.row];
	cell.textLabel.text = [item entryText];
	if ([item entryChecked]) {
		[cell setAccessoryType: UITableViewCellAccessoryCheckmark];
	}
	
    return cell;
} 
/*
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	[self.tableView2 deselectRowAtIndexPath:indexPath animated:YES];
}
*/

-(void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath: (NSIndexPath *) indexPath {
	
	if (editingStyle == UITableViewCellEditingStyleDelete) {
		
		if (indexPath.row < [entries count]) {
			[entries removeObjectAtIndex:indexPath.row];
		}
		[tableView2 deleteRowsAtIndexPaths:[NSArray arrayWithObject: indexPath] withRowAnimation: YES];
		
	}
}


-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	[self.tableView2 deselectRowAtIndexPath:indexPath animated:YES];
	
	NSLog(@"User selected row %d\n", [indexPath row] + 1);
	if ([[tableView2 cellForRowAtIndexPath:indexPath]accessoryType] == UITableViewCellAccessoryCheckmark)
	{
		[[tableView2 cellForRowAtIndexPath:indexPath] setAccessoryType:UITableViewCellAccessoryNone];
		// Checked Flag zurücksetzen
		EntryItem *item = [self.entries objectAtIndex:[indexPath row]];
		item.entryChecked = FALSE;
		[self.entries replaceObjectAtIndex:[indexPath row] withObject:item];
	}
	else
	{
		[[tableView2 cellForRowAtIndexPath:indexPath] setAccessoryType: UITableViewCellAccessoryCheckmark];
		// Checked Flad setzen
		EntryItem *item = [self.entries objectAtIndex:[indexPath row]];
		item.entryChecked = TRUE;
		[self.entries replaceObjectAtIndex:[indexPath row] withObject:item];		
	}
	[self performSelector: @selector(deselect:) withObject: nil afterDelay: 0.5f];
}

-(void)deselect: (id)sender {
	[self.tableView2 deselectRowAtIndexPath:[self.tableView2 indexPathForSelectedRow] animated:YES];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[entries release];
	[tableView2 release];
	[inputTextField release];
    [super dealloc];
}

@end
